var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function portName() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().portName;
	let action = arguments[1];

	return state;
}
function lastAction() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().lastAction;
	let action = arguments[1];

	return _.merge({}, action);
}
function experimentalFeature() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().experimentalFeature;
	let action = arguments[1];

	switch (action.type) {
		case EXPERIMENTAL_FEATURE:
			return _.merge({}, state, action.data);
			break;
		default:
			return state;
	}
}
function api() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().api;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_WITNESS:
			return _.merge({}, state, {
				key: action.data.key,
				id: action.data.id
			});
			break;
		default:
			return state;
	}
}
function rtApi() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().rtApi;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_RT_WITNESS:
			return _.merge({}, state, {
				key: action.data.key,
				id: action.data.id
			});
			break;
		default:
			return state;
	}
}
function common() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().common;
	let action = arguments[1];

	switch (action.type) {
		case GENERATE_ID:
			return _.merge({}, state, {
				[atob("Y2lk")]: action.data.id
			});
			break;
		default:
			return state;
	}
}
function retentionEvent() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().retentionEvent;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_RETENTION_DAYS:
			return _.merge({}, state, {
				sentDays: action.data.sentDays
			});
			break;
		case SAVE_RETENTION_COMPLETED:
			return _.merge({}, state, {
				completed: true
			});
			break;
		default:
			return state;
	}
}
function installEventFired() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().installEventFired;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_INSTALL:
			return true;
			break;
		default:
			return state;
	}
}
function firstRunDate() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().firstRunDate;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_FIRST_RUN_DATE:
			return action.data.firstRunDate;
			break;
		default:
			return state;
	}
}
function tabs() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().tabs;
	let action = arguments[1];

	let _state = {};
	switch (action.type) {
		case SAVE_TABS:
			let _tabs = action.data.tabs;
			for (let tab of _tabs) {
				_state[tab.id] = _.merge({}, tab);
				if (action.data.activeWindow && _state[tab.id].active == true && _state[tab.id].windowId != action.data.activeWindow.id) {
					_state[tab.id].active = false;
				}
			}
			return _state;
			break;
		case SET_ACTIVE_TAB:
			const newTabs = {};
			for (let tabId in state) {
				newTabs[tabId] = _extends({}, state[tabId], { active: tabId === action.data.tabId.toString() });
			}
			return newTabs;
		default:
			return state;
	}
}
function whitelist() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().whitelist;
	let action = arguments[1];

	switch (action.type) {
		case ADD_TO_WHITELIST:
			if (state.indexOf(action.data.host) === -1) {
				return [].concat(_toConsumableArray(state), [action.data.host]);
			}
			return state;
			break;
		case REMOVE_FROM_WHITELIST:
			let _state = [];
			for (let index in state) {
				action.data.host != state[index] && _state.push(state[index]);
			}
			return _state;
			break;
		default:
			return state;
	}
}
function templist() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().templist;
	let action = arguments[1];

	switch (action.type) {
		case ADD_TO_TEMPLIST:
			return [].concat(_toConsumableArray(state), [action.data.host]);
			break;
		case CLEAR_TEMPLIST:
			return DefaultState.getDefaultStateObject().templist;
			break;
		default:
			return state;
	}
}
function ratings() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().ratings;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_RATING:
			let _state = _.merge({}, state);
			if (Object.keys(_state).length > MAX_CACHE_SIZE) {
				// console.log("MAX CACHE");
				for (let host in _state) {
					if (+new Date() - _state[host].updated >= STORE_RATING_PERIOD) {
						// console.log("DELETE",_state[host], host);
						delete _state[host];
					}
				}
			}
			return _.merge({}, _state, action.data);
			break;
		case CLEAR_RATING:
			return _.merge({}, DefaultState.getDefaultStateObject().ratings);
			break;
		default:
			return state;
	}
}
function comments() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().comments;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_COMMENTS:
			let hostname = Object.keys(action.data)[0];
			if (state[hostname] && state[hostname].count && state[hostname].data.length > 0) {
				let _state = _.merge({}, state, { loading: false });
				_state[hostname].data = _.concat(_state[hostname].data, action.data[hostname].data);
				return _state;
			} else {
				return _.merge({}, state, action.data, { loading: false });
			}
			break;
		case CLEAR_COMMENTS:
			if (action.host) {
				let _state = _.merge({}, state);
				delete _state[action.host];
				return _state;
			} else {
				return _.merge({}, DefaultState.getDefaultStateObject().comments);
			}
			break;
		case LOADING_COMMENTS:
			DefaultState.getDefaultStateObject().comments.loading = true;
			return _.merge({}, state, DefaultState.getDefaultStateObject().comments);
			break;
		default:
			return state;
	}
}
function reviews() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().reviews;
	let action = arguments[1];

	let _state = _.merge({}, state),
	    host = action.data && action.data.host,
	    userId = action.data && action.data.userId || 1,
	    rating = action.data && action.data.rating,
	    review = action.data && action.data.review,
	    rate = action.data && action.data.rate,
	    id = action.data && action.data.id;
	if (host && userId && !_state[userId]) {
		_state[action.data.uid] = {};
	}
	switch (action.type) {
		case CLEAR_USER_REVIEWS:
			if (!_state[userId]) return state;
			delete _state[userId];
			return _state;
			break;
		case UPDATE_REVIEW_TIMESTAMP:
			if (!_state[userId]) return state;
			if (!_state[userId][host]) _state[userId][host] = {};
			_state[userId][host].reviewLastUpdateTimestamp = new Date().getTime();
			return _state;
			break;
		case DELETE_REVIEW_TIMESTAMP:
			if (!_state[userId]) return state;
			if (!_state[userId][host]) _state[userId][host] = {};
			_state[userId][host].reviewLastUpdateTimestamp = null;
			return _state;
			break;
		case SAVE_USER_REVIEW_FROM_API:
			if (!_state[action.data.uid]) _state[action.data.uid] = {};
			_state[action.data.uid][host] = _extends({}, action.data);
			_state[action.data.uid][host].reviewLastUpdateTimestamp = new Date().getTime();
			return _state;
			break;
		case SAVE_USER_DATA:
			if (!_state[action.data.uid]) {
				_state[action.data.uid] = {};
				for (let host in _state[1]) {
					if (host == action.host) {
						_state[action.data.uid][host] = _.merge({}, _state[1][host]);
						if (_state[1][host].step > 1) {
							// prevent delete review after get empty user comment from scorecard after login
							// only if unauth user make ratingflow steps
							_state[action.data.uid][host].reviewLastUpdateTimestamp = new Date().getTime();
						} else {
							// if unauth user has no rating flow steps then we
							// make timestamp zero to get reviwes data from server when user reopen popup
							_state[action.data.uid][host].reviewLastUpdateTimestamp = 0;
						}
						_state[1][host] = {
							step: 0,
							safetyCategories: [],
							childSafetyCategories: [],
							reputationCategories: [],
							rating: -1
						};
					} else {
						_state[action.data.uid][host] = {
							step: 0,
							safetyCategories: [],
							childSafetyCategories: [],
							reputationCategories: [],
							rating: -1
						};
					}
				}
			}
			return _state;
			break;
		case SAVE_RATING:
			for (let userId in _state) {
				if (Object.keys(_state[userId]).length > MAX_CACHE_SIZE) {
					// console.log("MAX CACHE");
					for (let host in _state[userId]) {
						if (_state[userId][host] && _state[userId][host].step == 0) {
							// console.log("DELETE",_state[host], host);
							delete _state[userId][host];
						}
					}
				}
				for (let host in action.data) {
					if (!_state[userId][host]) {
						_state[userId][host] = {
							step: 0,
							safetyCategories: [],
							childSafetyCategories: [],
							reputationCategories: [],
							rating: -1
						};
					}
				}
			}
			return _state;
			break;
		case CLEAR_RATING:
			for (let userId in _state) {
				// console.log("MAX CACHE");
				for (let host in _state[userId]) {
					if (_state[userId][host] && _state[userId][host].step == 0) {
						// console.log("DELETE",_state[host], host);
						delete _state[userId][host];
					}
				}
			}
			return _.merge(_state);
			break;
		case SAVE_REVIEW:
			_state[userId] = _.merge(_state[userId], review);
			return _state;
			break;
		case TO_NEXT_STEP:
			_state[userId][host] && _state[userId][host].step++;
			if (_state[userId][host].step > 6) _state[userId][host].step = 6;
			return _state;
			break;
		case TO_PREVIOUS_STEP:
			_state[userId][host] && _state[userId][host].step--;
			return _state;
			break;
		case OVER_NEXT_STEP:
			_state[userId][host].step = _state[userId][host].step + 2;
			return _state;
			break;
		case OVER_PREVIOUS_STEP:
			_state[userId][host].step = _state[userId][host].step - 2;
			return _state;
			break;
		case TRIPLE_NEXT_STEP:
			_state[userId][host].step = _state[userId][host].step + 3;
			return _state;
			break;
		case TRIPLE_PREVIOUS_STEP:
			_state[userId][host].step = _state[userId][host].step - 3;
			return _state;
			break;
		case RATE_SAFETY:
			if (rate == -1) {
				delete _state[userId][host].safety;
				rate = true;
			} else {
				_state[userId][host].safety = rate;
				if (rate == true && _state[userId][host].safetyCategories.indexOf(501) === -1) {
					_state[userId][host].safetyCategories.push(501);
				}
				if (_state[userId][host].safety) {
					_state[userId][host].safetyCategories = [];
				}
			}
			return _state;
			break;
		case PRESS_SAFETY_CATEGORY:
			_state[userId][host].safetyCategories = _.xor(_state[userId][host].safetyCategories, [id]);
			return _state;
			break;
		case RATE_CHILD_SAFETY:
			if (rate == -1) {
				delete _state[userId][host].childSafety;
				rate = true;
			} else {
				_state[userId][host].childSafety = rate;
				if (_state[userId][host].childSafety) {
					_state[userId][host].childSafetyCategories = [];
				}
			}
			return _state;
			break;
		case PRESS_CHILD_SAFETY_CATEGORY:
			_state[userId][host].childSafetyCategories = _.xor(_state[userId][host].childSafetyCategories, [id]);
			return _state;
			break;
		case PRESS_REPUTATION_CATEGORY:
			_state[userId][host].reputationCategories = _.xor(_state[userId][host].reputationCategories, [id]);
			return _state;
			break;
		case RATE_SITE:
			_state[userId][host].rating = rating;
			return _state;
			break;
		case EDIT_REVIEW:
			_state[userId][host].step = 1;
			return _state;
			break;
		case DELETE_REVIEW:
			_state[userId][host] = {
				step: 0,
				safetyCategories: [],
				childSafetyCategories: [],
				reputationCategories: [],
				rating: -1
			};
			return _state;
			break;
		case DELETE_REVIEW_BEFORE_CHILD:
			_state[userId][host].safetyCategories = [];
			_state[userId][host].reputationCategories = [];
			return _state;
			break;
		case DELETE_REVIEW_BEFORE_REPUTATION:
			_state[userId][host].safetyCategories = [];
			return _state;
			break;
		case ADD_COMMENT:
			_state[userId][host].comment = action.data.comment;
			_state[userId][host].timestamp = action.data.timestamp;
			return _state;
			break;
		default:
			return state;
	}
}
function user() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().user;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_USER_TOKEN:
			return _.merge({}, DefaultState.getDefaultStateObject().user, { token: action.data.token });
			break;
		case SAVE_USER_DATA:
			return _.merge({}, state, action.data);
			break;
		case CLEAN_USER_DATA:
			return _.merge({}, DefaultState.getDefaultStateObject().user);
			break;
		case ERROR_USER_AUTH:
			return _.merge({}, DefaultState.getDefaultStateObject().user);
			break;
		default:
			return state;
	}
}
function serps() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().serps;
	let action = arguments[1];

	switch (action.type) {
		case SAVE_SERPS_CONF:
			return action.data;
			break;
		default:
			return state;
	}
}
function settings() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().settings;
	let action = arguments[1];
	let host = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

	switch (action.type) {
		case PROTECTION_ON:
			return _.merge({}, state, { protection: true });
			break;
		case PROTECTION_OFF:
			return _.merge({}, state, { protection: false });
			break;
		case PARENTAL_CONTROL_ON:
			return _.merge({}, state, { parental: true });
			break;
		case PARENTAL_CONTROL_OFF:
			return _.merge({}, state, { parental: false });
			break;
		case SET_DONUTS_LEVEL:
			if (action.data.id == 'all') {
				let _donuts = _.merge({}, state.donuts);
				for (let id in _donuts) {
					_donuts[id] = action.data.level;
				}
				return _.merge({}, state, { donuts: _donuts });
			} else {
				return _.merge({}, state, { donuts: { [action.data.id]: action.data.level } });
			}
			break;
		case SET_WARNINGS_LEVEL:
			return _.merge({}, state, { warnings: action.data.level });
			break;
		default:
			return state;
	}
}
function rateUsWidget() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().rateUsWidget;
	let action = arguments[1];

	switch (action.type) {
		case COUNT_POPUP_OPENING:
			return _.merge({}, state, { popupOpeningCounter: state.popupOpeningCounter + 1 });
		case OFF_RATE_WIDGET:
			let offRateTime = new Date();
			offRateTime.setMonth(offRateTime.getMonth() + 2);
			return _.merge({}, state, { offRateWidget: true, offRateTime: offRateTime });
		case CHECK_RATE_WIDGET_DATE:
			if (state.offRateTime <= new Date()) {
				return _.merge({}, state, { offRateWidget: false, offRateTime: '' });
			}
			return state;
		default:
			return state;
	}
}
function mobileModal() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().mobileModal;
	let action = arguments[1];

	switch (action.type) {
		case MOBILE_TRIGGER_MODAL:
			return _.merge({}, state, { mobileModalTrigger: true });
		case MOBILE_RATE_COUNT:
			if (state.mobileModalRateCount < 2) {
				return _.merge({}, state, { mobileModalRateCount: state.mobileModalRateCount + 1, mobileModalTrigger: false });
			} else {
				return _.merge({}, state, { mobileModalTrigger: true, mobileModalRateCount: 0 });
			}
		case MOBILE_TRIGGER_MODAL_RESET:
			return _.merge({}, state, { mobileModalTrigger: false });
		default:
			return state;
	}
}
function onboarding() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().onboarding;
	let action = arguments[1];

	switch (action.type) {
		case TO_NEXT_STEP_ONBOARDING:
			if (action.data.step || action.data.step === 0) {
				state.step = action.data.step;
			} else {
				state.step++;
			}
			return _.merge({}, state);
			break;
		default:
			return _.merge({}, state);
	}
}
function cta() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().cta;
	let action = arguments[1];

	switch (action.type) {
		case UPDATE_CTA_STATUS:
			state.status = action.data;
			return _.merge({}, state);
			break;
		case UPDATE_CTA_APPEARANCE:
			if (state.appearance === 3) {
				state.status = 'dontShowAgain';
			} else {
				state.appearance++;
			}
			return _.merge({}, state);
			break;
		default:
			return _.merge({}, state);
	}
}
function survey() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().survey;
	let action = arguments[1];

	switch (action.type) {
		case UPDATE_SURVEY_STATE:
			return _.merge({}, action.data.newSurveyState);
		case MAKE_SURVEY_SHOWED:
			return _extends({}, state, {
				isShowed: true
			});
		default:
			return _.merge({}, state);
	}
}
function GDPRNotifications() {
	let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultState.getDefaultStateObject().GDPRNotifications;
	let action = arguments[1];

	switch (action.type) {
		case SET_GDPR_NOTIFICATIONS:
			return true;
			break;
		case SET_GDPR_NOTIFICATIONS_OFF:
			return false;
			break;
		default:
			return state;
	}
}
const reducers = Redux.combineReducers({
	portName,
	lastAction,
	api,
	rtApi,
	common,
	retentionEvent,
	installEventFired,
	firstRunDate,
	whitelist,
	templist,
	tabs,
	ratings,
	comments,
	reviews,
	user,
	serps,
	settings,
	rateUsWidget,
	experimentalFeature,
	mobileModal,
	onboarding,
	cta,
	survey,
	GDPRNotifications
});