var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

webextApi.storage.local.get([STORAGE_TOKEN, FIREFOX_STORAGE_TOKEN], value => {
	let store;
	if (browserName === 'firefox' && (!value[STORAGE_TOKEN] || !!value[STORAGE_TOKEN].firstRunDate) && value[FIREFOX_STORAGE_TOKEN]) {
		localStorage.setItem("settingsui_parental", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].settingsui_parental));
		localStorage.setItem("settingsui_dynamicprotect", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].settingsui_dynamicprotect));
		localStorage.setItem("rtp_has_user_selected", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].rtp_has_user_selected));
		localStorage.setItem("settingsui_searchlevel", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].settingsui_searchlevel));
		localStorage.setItem("settingsui_warnlevel", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].settingsui_warnlevel));
		localStorage.setItem("rt_witness_id", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].rt_witness_id));
		localStorage.setItem("rt_witness_key", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].rt_witness_key));
		localStorage.setItem("witness_id", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].witness_id));
		localStorage.setItem("witness_key", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].witness_key));
		localStorage.setItem("firstrun:time", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].stats_installtime));
		localStorage.setItem("firstrun:welcome", JSON.stringify(value[FIREFOX_STORAGE_TOKEN].stats_installtime));
	}
	let defaultState = DefaultState.getDefaultStateObject(true);
	if (DEV_MODE) {
		const loggerMiddleware = reduxLogger.createLogger();
		store = Redux.createStore(reducers, value[STORAGE_TOKEN] || defaultState, Redux.compose(Redux.applyMiddleware(alias(aliases), ReduxThunk.default, loggerMiddleware)));
	} else {
		setTimeout(e => {
			localStorage.clear();
		}, 1000 * 60);
		store = Redux.createStore(reducers, value[STORAGE_TOKEN] || defaultState, Redux.compose(Redux.applyMiddleware(alias(aliases), ReduxThunk.default)));
	}
	wrapStore(store, { portName: "4873" });
	setTimeout(() => {
		window.app = new MainApp(store);
		window.addEventListener('message', event => {
			console.log(event);
			if (event && event.data && event.data.status === 'login') {
				store.dispatch(saveToken(event.data.token));
			}
		});
	}, browserName === 'firefox' ? 1000 : 0);
});
const _wotPloyder = new class _WotPloyderClass {
	constructor() {
		this._ploys = [];
		this.limit = 10;
		this.v = 1.01;
	}
	getMeta() {
		return { type: "pymeta", l: this.limit, v: this.v };
	}
	push(ploy) {
		return this._ploys.push(ploy);
	}
	unshift(ploy) {
		this._ploys.unshift(ploy);
		return this;
	}
	getAll() {
		return this._ploys;
	}
	take() {
		let limit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

		if (limit === 0) {
			return this.takeAll();
		} else {
			return this.getAll().splice(0, limit);
		}
	}
	takeAll() {
		return this._ploys.splice(0, this._ploys.length);
	}
	hasItems() {
		return this._ploys.length > 0;
	}
	takeAndPack() {
		let limit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

		return encodeURIComponent(JSON.stringify([this.getMeta()].concat(_toConsumableArray(this.take(limit)))));
	}
	getDomainName(href) {
		var l = document.createElement("a");
		l.href = href;
		return l.hostname;
	}
	lkify(typeInfo, data, sender) {
		const isFas = typeInfo.type === "fas",
		      isGas = typeInfo.type === "gas",
		      tabInfo = {
			tid: sender.tab.id,
			turl: isFas ? this.getDomainName(sender.tab.url) : decodeURIComponent(sender.tab.url)
		};
		data.meta = _extends({}, tabInfo, {
			subtype: typeInfo.subtype
		});
		let fort = {
			type: typeInfo.type,
			data
		};
		if (isGas && sender.frameId !== 0) {
			fort.data.fr.fId = sender.frameId;
		}
		if (isFas && data.elid) {
			const ol = this.getAll().filter(e => e.type === "fas" && e.data.elid === data.elid)[0];
			if (ol) Object.assign(ol.data, data);else this.push(fort);
		} else {
			this.push(fort);
		}
	}
}();