
class ReputationBubble extends React.Component {
	render() {
		var _props = this.props;
		let rating = _props.rating,
		    confidence = _props.confidence,
		    settings = _props.settings;

		let stars = [],
		    color;
		switch (true) {
			case confidence < MIN_REPUTATION_CONFIDENCE:
				color = 'gray';
				break;
			case confidence >= MIN_REPUTATION_CONFIDENCE && rating > 0 && rating <= MAX_REPUTATION_RED:
				color = 'red';
				break;
			case confidence >= MIN_REPUTATION_CONFIDENCE && rating > MAX_REPUTATION_RED && rating <= MAX_REPUTATION_YELLOW:
				color = 'yellow';
				break;
			case confidence >= MIN_REPUTATION_CONFIDENCE && rating > MAX_REPUTATION_YELLOW:
				color = 'green';
				break;
			default:
				break;
		}
		for (let i = 1; i <= 5; i++) {
			let difference = 20 * i - rating;
			if (color !== 'gray') {
				stars.push(React.createElement('div', {
					className: "reputation__star " + (difference <= 5 ? "reputation__star_full" : difference <= 15 ? "reputation__star_half" : "")
				}));
			} else {
				stars.push(React.createElement('div', { className: 'reputation__star' }));
			}
		}
		return React.createElement(
			'div',
			{ className: 'reputation-container' },
			React.createElement(
				'div',
				{ className: 'reputation__label' },
				React.createElement(
					'span',
					null,
					webextApi.i18n.getMessage("Reputation")
				)
			),
			React.createElement(
				'div',
				{ className: "reputation__circle reputation__circle_" + color },
				React.createElement(
					'span',
					null,
					color !== 'gray' ? (rating / 20).toFixed(1) : "?"
				)
			),
			React.createElement(
				'div',
				{ className: 'reputation__stars' },
				stars
			)
		);
	}
}
ReputationBubble.propTypes = {
	rating: React.PropTypes.number.isRequired,
	confidence: React.PropTypes.number.isRequired
};
function mapStateToPros(state) {
	return { settings: state.settings };
}
ReputationBubble = ReactRedux.connect(mapStateToPros)(ReputationBubble);