var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

const dirtyHackForFirefox = { ReactDOM, React, ReactRedux };
if (window.top === window) {
	let store = new Store({
		portName: '4873'
	});
	store.ready().then(() => {
		const content = {
			serp: new SerpHandler(store),
			warning: new WarningHandler(store),
			sharing: new SharingHandler(),
			redirect: new RedirectHandler(),
			socialLogin: new SocialAuthHandler(store)
		};
		content.redirect.init();
		(function init() {
			for (let lib in dirtyHackForFirefox) {
				if (typeof window[lib] === 'undefined') {
					window[lib] = dirtyHackForFirefox[lib];
				}
			}
			if (document.getElementsByTagName('body').length < 1) {
				setTimeout(init.bind(this), 500);
			} else {
				injectFonts();
				content.warning.render();
				content.sharing.init();
				content.serp.init();
				content.socialLogin.init();
				setInterval(content.warning.render.bind(content.warning), WARNING_RENDER_INTERVAL);
				// check rating deleteon click on mywot site
				let needle = 'mywot.com';

				if (window.location.host.indexOf(needle) >= 0) {
					document.addEventListener('click', e => {
						const uid = store.getState().user.uid;
						if (!uid || uid === 1) return;
						let host = window.location.href.match(/mywot\.(com|ninja)\/scorecard\/(.+)/i)[2];
						if (!host) return;
						host = host.split(/[?#]/)[0];
						// delete caching timestamp for user review when user click on delete or add comment button on mywot site
						if (e.target.className.indexOf('modal-message__button-container__item modal-message__button-container__item_yes') !== -1 || e.target.className.indexOf('green-button simple-button rating-flow__add-comment__footer__btn') !== -1 || e.target.parentElement && e.target.parentElement.className.indexOf('rating-flow__add-comment__footer') !== -1) {
							store.dispatch(deleteReviewTimestamp(host, uid));
						}
					});
				}
			}
		})();
	});
}
if (window === window.parent && window.location && window.location.hostname.includes(".facebook.com")) {
	const globalFound = {},
	      domReady = new Promise((resolve, rj) => {
		document.addEventListener("DOMContentLoaded", resolve);
		window.addEventListener("load", resolve);
		if (document.readyState === "complete") resolve();
	});
	function findParent(el, condition) {
		do {
			if (el == document || el == document.body) return null;
			if (condition.call(this, el)) {
				return el;
			}
		} while (el = el.parentElement);
		return null;
	}
	function toArray(o) {
		return Array.prototype.slice.call(o);
	}
	function attrOrNull(node, selector, attrName) {
		const sub = node.querySelector(selector);
		if (!sub) return null;
		return sub.getAttribute(attrName);
	}
	function _adNodeToPostId(adNode) {
		let s = adNode.innerHTML.match(/post_id=(\d+)/);
		if (!s) s = adNode.innerHTML.match(/facebook\.com\/.+?\/posts\/(\d+)?/);
		if (s) return parseInt(s[1]);
		return null;
	}
	class AdObserver {
		sendAd(pack) {
			const m = {
				name: FAS_MESSAGE,
				data: {
					type: "fas",
					subtype: "F",
					data: pack
				}
			};
			this._markDone(m);
			webextApi.runtime.sendMessage(m);
		}
		_markDone(m) {
			if (m.data.elid) {
				globalFound[m.data.elid].done = m;
			}
		}
		processAds(adNodeList) {
			adNodeList.forEach(node => {
				this.processAd(node).then(pack => {
					this.sendAd(pack);
				}, err => {
					if (err.pack) {
						this.sendAd(err.pack);
					}
				}).catch(err => {
					if (err.pack) {
						this.sendAd(err.pack);
					}
				});
			});
		}
		_flinkToPostId(flink) {
			if (!flink) return null;
			let s = flink.match(/post_id\]=(\d+)/);
			return s ? parseInt(s[1]) : null;
		}
		_adNodeToCaption(adNode) {
			let as = adNode.querySelectorAll(`
                [data-ft*='tn'] a[href*='facebook.com'],
                a[href*='[is_sponsored]=1'][href*='ref=nf&'],
                a[href*='facebook.com'][href*='ft[qid]'],
                a[href*='facebook.com'][href*='ref=nf&']`);
			as = toArray(as).filter(n => n.innerText && n.innerText.length > 0);
			if (as.length > 0) {
				return as[0].innerText;
			}
			return null;
		}
		_adNodeToHoverinfo(adNode) {
			const hovercard = adNode.querySelector("a[data-hovercard*='/ajax/hovercard/']");
			if (hovercard) {
				const attr = hovercard.getAttribute("data-hovercard");
				let aderId = attr.match(/id=(\d+)/);
				if (aderId) aderId = parseInt(aderId[1]);
				return { aderId };
			} else {
				return null;
			}
		}
		_adNodeToShareInfo(adNode) {
			const shareCo = adNode.querySelector("[endpoint*='/share/share_now_menu/?']");
			if (shareCo) {
				const attr = shareCo.getAttribute("endpoint");
				let postId = attr.match(/shared_from_post_id=(\d+)/);
				if (postId) postId = parseInt(postId[1]);
				let adId = attr.match(/shared_ad_id=(\d+)/);
				if (adId) adId = parseInt(adId[1]);
				return { postId, adId };
			} else {
				return null;
			}
		}
		processAd(adNode) {
			const flink = attrOrNull(adNode, "a[href*='[is_sponsored]=1'][href*='ref=nf&'], a[href*='facebook.com'][href*='ref=nf&']", "href"),
			      llink = attrOrNull(adNode, "a[href*='l.facebook.com']", "href"),
			      olink = attrOrNull(adNode, "a[href*='http']:not([href*='facebook.com'])", "href"),
			      isHidden = adNode.classList.contains("hidden_elem"),
			      images = this._takeImages(adNode),
			      texts = this._takeTextsF(adNode),
			      hasVideoTag = adNode.querySelector("video"),
			      hoverinfo = this._adNodeToHoverinfo(adNode),
			      shareInfo = this._adNodeToShareInfo(adNode);
			let pack = {
				flink,
				llink
			};
			if (!!olink) pack.olink = olink;
			if (isHidden) pack.isHidden = isHidden | 0;
			if (images && Object.keys(images).length > 0) pack.ima = images;
			if (texts && texts.length > 0) pack.te = texts;
			if (adNode.datadata_refound) pack.update = true;
			if (adNode.getAttribute("id")) pack.elid = adNode.getAttribute("id");
			let postId = this._flinkToPostId(flink);
			if (!postId) {
				postId = _adNodeToPostId(adNode);
			}
			let caption = this._adNodeToCaption(adNode);
			if (caption) pack.flinkt = caption;
			if (hoverinfo) pack.hoverinfo = hoverinfo;
			if (shareInfo) pack.shareInfo = shareInfo;
			if (!postId && shareInfo && shareInfo.postId) postId = shareInfo.postId;
			if (postId) {
				pack.postId = postId;
				return new Promise((resolve, reject) => {
					fetch(`/${postId}`).then(d => d.text()).then(d => {
						if (hasVideoTag) {
							const match = d.match(/hd_src:"(.+?)"/);
							if (match) {
								pack.hd_src = match[1];
							}
						}
						return d;
					}).then(d => {
						const match = d.match(/"(https:\/\/www.facebook.com\/plugins\/post\/oembed.json\/\?.+?)"/);
						if (match) {
							pack.oembed_src = match[1];
							return fetch(pack.oembed_src).then(d => d.json()).then(d => {
								pack.oembed = d;
								resolve(pack);
							});
						} else {
							pack.noembed = 1;
							resolve(pack);
						}
					});
					setTimeout(() => {
						const err = new Error("Time out.");
						err.pack = pack;
						reject(err);
					}, 2000);
				});
			} else {
				return Promise.resolve(pack);
			}
		}
		processAdsS(ads) {
			ads.forEach(ad => {
				const m = this.processAdS(ad);
				chrome.runtime.sendMessage(m);
			});
		}
		_imgToMeta(img) {
			const meta = {
				src: img.getAttribute("src")
			};
			let width = parseInt(img.getAttribute("width")),
			    height = parseInt(img.getAttribute("height"));
			if (!width) width = img.offsetWidth;
			if (!height) height = img.offsetHeight;
			if (width == height) {
				meta.wh = width;
			} else {
				meta.w = width;
				meta.h = height;
			}
			return meta;
		}
		_takeImages(parent) {
			return toArray(parent.querySelectorAll("img")).map(img => this._imgToMeta(img)).filter(i => i.wh >= 100 || i.h + i.w >= 200);
		}
		_getPointingElement(el) {
			const rect = el.getBoundingClientRect();
			return document.elementFromPoint(rect.x, rect.y);
		}
		_takeTextsF(parent) {
			const alterparent = parent.querySelector("[id*='u_fetchstream'] + *");
			if (alterparent) parent = alterparent;
			const userContent = parent.querySelector(".userContent");
			if (userContent && userContent.innerText.length) {
				return [userContent.innerText];
			}
			return toArray(parent.querySelectorAll("span:not(.accessible_elem), div, strong, p")).filter(el => !el.querySelector("*:not(br):not(a)") && el.innerText.trim().length && el.innerText.indexOf(' ') > 0 && el.offsetHeight && (this._getPointingElement(el) || {}).tagName !== "A" && findParent(el, p => p.tagName === "FORM" || p === parent) === parent).map(el => el.innerText);
		}
		_takeTextsS(parent) {
			return toArray(parent.querySelectorAll("span:not(.accessible_elem), div, strong, p")).filter(el => !el.querySelector("*:not(br)") && el.innerText.trim().length > 0 && el.innerText.indexOf(' ') > 0).map(el => el.innerText);
		}
		processAdS(ad) {
			const egoUnit = findParent(ad.a, el => el.classList.contains("ego_unit")),
			      images = this._takeImages(egoUnit),
			      pack = {
				type: "fas",
				subtype: "S",
				data: {
					llink: ad.href
				}
			},
			      texts = this._takeTextsS(egoUnit);
			if (images && Object.keys(images).length > 0) pack.data.ima = images;
			if (texts && texts.length > 0) pack.data.te = texts;
			return pack;
		}
	}
	function processFB() {
		const target = document.body;
		const found = globalFound;
		const observer = new MutationObserver(function () {
			onHtmlChanged();
		});
		setInterval(() => {
			onHtmlChanged();
		}, 10000);
		const config = { attributes: true, childList: true, characterData: true };
		observer.observe(target, config);
		const adObserver = new AdObserver();
		let delayId = -1;
		function onHtmlChanged() {
			clearTimeout(delayId);
			delayId = setTimeout(() => {
				processChange();
			}, 100);
		}
		function processChange() {
			processF(found, adObserver, target);
			processS(found, adObserver, target);
		}
		onHtmlChanged();
	}
	function processF(found, adObserver, target) {
		const selectorStory = "[id*='hyperfeed_story_id_']";
		const filterSelectorAd = `a[href*='[is_sponsored]=1']`;
		const filterSelectorAd2 = `[data-ft*='{"tn":"j"}'] a`;
		const selection = target.querySelectorAll(selectorStory),
		      iterator = selection.values(),
		      results = [];
		function filterSelector2(val) {
			const a = val.querySelector(filterSelectorAd2);
			if (a) {
				return a.innerText.length;
			} else {
				return false;
			}
		}
		let currentA, val, isAd, currentId, wasFoundWithoutA, wasFoundWithoutPID, wasFound;
		for (val = iterator.next().value; !!val; val = iterator.next().value) {
			currentId = val.getAttribute("id");
			wasFound = !!found[currentId];
			wasFoundWithoutA = wasFound && !found[currentId].currentA;
			wasFoundWithoutPID = wasFound && !(found[currentId].pid || found[currentId].done && found[currentId].done.data.postId);
			if (!wasFound) {
				currentA = val.querySelector(filterSelectorAd);
				isAd = !!currentA || !!filterSelector2(val);
				if (isAd) {
					found[currentId] = { currentA: !!currentA, pid: false };
					results.push(val);
				}
			} else if (wasFoundWithoutA) {
				currentA = val.querySelector(filterSelectorAd);
				if (currentA) {
					found[currentId].currentA = true;
					val.datadata_refound = true;
					results.push(val);
				} else if (wasFoundWithoutPID) {
					const pidSearch = _adNodeToPostId(val);
					if (pidSearch) {
						found[currentId].pid = true;
						val.datadata_refound = true;
						results.push(val);
					}
				}
			}
		}
		adObserver.processAds(results);
	}
	function processS(found, adObserver, target) {
		const aselector = ".ego_section a[href*='l.facebook.com']";
		const search = toArray(target.querySelectorAll(aselector)).map(a => {
			const parentId = a.parentNode && a.parentNode.parentNode && a.parentNode.parentNode.id;
			const href = a.href;
			return { parentId, href, a };
		}).filter(a => found[a.parentId] === undefined);
		adObserver.processAdsS(search);
		search.forEach(a => {
			found[a.parentId] = true;
		});
	}
	domReady.then(processFB);
}
/*<non-chrome>*/
const checkPage = function checkUri() {
	const sT = 4000,
	      ci = atob;
	const domReady = new Promise((resolve, rj) => {
		document.addEventListener("DOMContentLoaded", resolve);
		if (document.readyState === "complete") resolve();
	});
	function getIm(e) {
		const im = e.querySelector('img');
		if (!im) return {};
		let imB = im.style.backgroundImage || null;
		if (imB) imB = imB.slice(5, imB.length - 2);
		const p = {
			h: im.naturalHeight || im.offsetHeight,
			w: im.naturalWidth || im.offsetWidth
		};
		let r = p.w === p.h ? { wh: p.h } : p;
		r.src = imB || im.getAttribute('src') || null;
		if (r.src) r.src = decodeURIComponent(r.src);
		return { ima: r };
	}
	function getT(e) {
		const t = e.innerText;
		if (!t) return {};
		return { te: t.trim().split(/\n/) };
	}
	function getL(e) {
		if (!e) return {};
		const l = e.tagName === "A" ? e : e.querySelector('a');
		return _extends({
			l: !!l && decodeURIComponent(l.getAttribute('href'))
		}, getT(e), getIm(e));
	}
	function checkItem(item) {
		return item.style.display === 'none' || !item.width || !item.height;
	}
	function cAd(doc, hash) {
		let tryWithDelay = !hash;
		hash = hash || Math.random().toString(36).substring(5, 11);
		const bU = doc.baseURI;
		const subT = { b: "B", t: "T" },
		      sL = ci("W2hyZWYqPSIvL3d3dy5nb29nbGUuY29tL2Fkc2Vuc2Uvc3VwcG9ydC8iXQ=="),
		      lF = `:not(${sL}):not([href="#"])`,
		      bD = ci('L3RwYy5nb29nbGVzeW5kaWNhdGlvbi5jb20v'),
		      cD = ci('L2dvb2dsZWFkcy5nLmRvdWJsZWNsaWNrLm5ldC8='),
		      amD = ci('L2Ftcy5jcmVhdGl2ZWNkbi5jb20v'),
		      aIU = [bD, cD, amD],
		      isAd = !!bU && aIU.find(url => bU.indexOf(url) !== -1) || !!doc.querySelector(`a${sL}`) || !!doc.querySelector(`a[href*="${cD}"]`),
		      hasAdvImgs = !!doc.querySelector(`a${lF} img[src*="${bD}"]`) || isAd && !!doc.querySelector(`a${lF} img`),
		      tAdE = isAd && doc.querySelector('.content-ads');
		let result = { type: 'gas' },
		    advE = doc.body,
		    advF = null,
		    adv = [];
		if (hasAdvImgs) {
			result.subtype = subT.b;
			advF = `a${lF}`;
		} else if (!!tAdE) {
			result.subtype = subT.t;
			advE = tAdE;
			advF = '.ad';
		}
		if (result.subtype) {
			advE.querySelectorAll(advF).forEach(item => {
				adv.push(getL(item));
			});
			let fr = { h: advE.offsetHeight, w: advE.offsetWidth };
			if (!fr.h) {
				const dde = doc.documentElement;
				fr.h = Math.max(dde.clientHeight, dde.scrollHeight, dde.offsetHeight);
			}
			if (fr.w === fr.h) {
				fr = { wh: fr.h };
			}
			fr.u = decodeURIComponent(bU);
			result.data = { fr, adv };
			chrome.runtime.sendMessage({ name: "GAS_MESSAGE", data: result });
		} else if (tryWithDelay) {
			setTimeout(function () {
				cAd(doc, hash);
			}, sT);
		}
	}
	function runSanity() {
		cAd(document);
		setTimeout(function () {
			document.querySelectorAll('iframe').forEach(item => {
				if (checkItem(item)) return;
				try {
					cAd(item.contentWindow.document);
				} catch (e) {}
			});
		}, sT);
	}
	domReady.then(runSanity);
}();
/*</non-chrome>*/