
class MainComponent extends React.Component {
	constructor(props) {
		super(props);
		document.title = 'WOT - ' + webextApi.i18n.getMessage('settings');
		this.state = {
			openDonuts: this.props.getParams.serpid ? true : false
		};
	}
	onLogoClick() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Settings",
				[atob("ZWE=")]: "WOT Logo",
				[atob("ZWw=")]: ""
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: MAIN_PAGE_URL + SETTINGS_REDIRECT_PARAMETERS });
	}
	openDonats() {
		this.setState({
			openDonuts: this.state.openDonuts ? false : true
		});
	}
	render() {
		var _props = this.props;
		let dispatch = _props.dispatch,
		    settings = _props.settings,
		    whitelist = _props.whitelist,
		    serps = _props.serps,
		    getParams = _props.getParams,
		    itemClass = 'options__container_item',
		    donutsList = [],
		    warningActions = [{
			action: setWarningsLevel,
			title: webextApi.i18n.getMessage("all"),
			arguments: WARNINGS_LEVEL_HIGH,
			params: {
				[atob("ZWM=")]: "Settings",
				[atob("ZWE=")]: "Warnings",
				[atob("ZWw=")]: "All"
			} }, {
			action: setWarningsLevel,
			title: webextApi.i18n.getMessage("severeOnly"),
			arguments: WARNINGS_LEVEL_NORMAL,
			params: {
				[atob("ZWM=")]: "Settings",
				[atob("ZWE=")]: "Warnings",
				[atob("ZWw=")]: "Severe Only"
			} }, { action: setWarningsLevel,
			title: webextApi.i18n.getMessage("off"),
			arguments: WARNINGS_LEVEL_OFF,
			params: {
				[atob("ZWM=")]: "Settings",
				[atob("ZWE=")]: "Warnings",
				[atob("ZWw=")]: "Off"
			} }];

		!settings.protection && (itemClass += ' options__container_item_not-protection_other');
		if (!window.eventSended) {
			webextApi.runtime.sendMessage({
				name: SEND_MESSAGE, params: {
					[atob("ZWM=")]: "Settings",
					[atob("ZWE=")]: "Open",
					[atob("ZWw=")]: ""
				}
			});
			window.eventSended = true;
		}
		let donutsListHeader = {
			id: 'all',
			host: 'all',
			level: settings.donuts.all,
			donutActions: [{
				action: setDonutsLevel,
				title: webextApi.i18n.getMessage("always"),
				arguments: DONUTS_LEVEL_HIGH,
				params: {
					[atob("ZWM=")]: "Settings",
					[atob("ZWE=")]: "Donuts",
					[atob("ZWw=")]: "All"
				} }, {
				action: setDonutsLevel,
				title: webextApi.i18n.getMessage("poorOnly"),
				arguments: DONUTS_LEVEL_NORMAL,
				params: {
					[atob("ZWM=")]: "Settings",
					[atob("ZWE=")]: "Donuts",
					[atob("ZWw=")]: "Poor Only"
				} }, {
				action: setDonutsLevel,
				title: webextApi.i18n.getMessage("off"),
				arguments: DONUTS_LEVEL_OFF,
				params: {
					[atob("ZWM=")]: "Settings",
					[atob("ZWE=")]: "Donuts",
					[atob("ZWw=")]: "Off"
				} }]
		};
		serps.map(function (item) {
			let dunutLvl = settings.donuts.all;
			_.forEach(settings.donuts, (value, key) => {
				if (new RegExp(item.domain).test(key)) {
					dunutLvl = value;
				}
			});
			donutsList.push({
				id: item.id,
				host: item.name,
				level: dunutLvl,
				donutActions: [{
					action: setDonutsLevel,
					title: webextApi.i18n.getMessage("always"),
					arguments: DONUTS_LEVEL_HIGH,
					params: {
						[atob("ZWM=")]: "Settings",
						[atob("ZWE=")]: "Donuts",
						[atob("ZWw=")]: "All"
					} }, {
					action: setDonutsLevel,
					title: webextApi.i18n.getMessage("poorOnly"),
					arguments: DONUTS_LEVEL_NORMAL,
					params: {
						[atob("ZWM=")]: "Settings",
						[atob("ZWE=")]: "Donuts",
						[atob("ZWw=")]: "Poor Only"
					} }, {
					action: setDonutsLevel,
					title: webextApi.i18n.getMessage("off"),
					arguments: DONUTS_LEVEL_OFF,
					params: {
						[atob("ZWM=")]: "Settings",
						[atob("ZWE=")]: "Donuts",
						[atob("ZWw=")]: "Off"
					} }]
			});
		});
		return React.createElement(
			'div',
			{ className: 'options' },
			React.createElement(
				'div',
				{ className: 'options__header' },
				React.createElement('div', { className: 'options__header__logo', onClick: this.onLogoClick.bind(this) }),
				React.createElement(
					'div',
					{ className: 'options__header__name' },
					webextApi.i18n.getMessage("settings")
				)
			),
			React.createElement(
				'div',
				{ className: 'options__container' },
				React.createElement(
					'div',
					{ className: itemClass },
					React.createElement(DescriptionOption, { title: webextApi.i18n.getMessage("warnings"), text: webextApi.i18n.getMessage(settings.warnings) }),
					React.createElement(RadioButtonContainer, { dispatch: dispatch, settings: settings, type: 'warnings', actions: warningActions })
				),
				React.createElement(
					'div',
					{ className: itemClass },
					React.createElement(DescriptionOption, {
						title: webextApi.i18n.getMessage("donuts"),
						text: webextApi.i18n.getMessage(donutsListHeader.level),
						clickAction: this.openDonats.bind(this),
						donutState: this.state.openDonuts }),
					React.createElement(RadioButtonContainer, {
						dispatch: dispatch,
						settings: settings,
						type: 'donuts',
						id: donutsListHeader.id,
						actions: donutsListHeader.donutActions })
				),
				React.createElement(
					'div',
					{ className: "options__container__donuts" + (this.state.openDonuts ? ' options__container__donuts_show' : '') },
					donutsList.map(item => {
						return React.createElement(
							'div',
							{ className: itemClass + (!!item.host && item.host !== 'all' ? ' options__container_item_site' : '') + (getParams.serpid && item.id == getParams.serpid ? ' highlight-donut' : '') },
							React.createElement(DescriptionOption, {
								title: " " + item.host,
								text: '' }),
							React.createElement(RadioButtonContainer, {
								dispatch: dispatch,
								settings: settings,
								type: 'donuts',
								id: item.id,
								actions: item.donutActions,
								donutState: this.state.openDonuts,
								host: item.host || '' })
						);
					})
				),
				React.createElement(
					'div',
					{ className: itemClass },
					React.createElement(DescriptionOption, { title: webextApi.i18n.getMessage("parentalControl"), text: webextApi.i18n.getMessage(settings.parental ? "parentalControlON" : "parentalControlOFF") }),
					React.createElement(CheckboxOption, {
						protection: settings.protection,
						check: !!settings.parental,
						dispatch: dispatch,
						actions: [turnOffParentalControl, turnOnParentalControl],
						type: 'Parental Control' })
				),
				React.createElement(
					'div',
					{ className: settings.protection ? "options__container_item" : "options__container_item options__container_item_not-protection" },
					React.createElement(DescriptionOption, {
						title: webextApi.i18n.getMessage(settings.protection ? "rtProtection" : "rtProtectionRecommended"),
						text: webextApi.i18n.getMessage(settings.protection ? "rtON" : "rtOFF"), policy: settings.protection }),
					React.createElement(CheckboxOption, {
						protection: true,
						check: !!settings.protection,
						dispatch: dispatch,
						actions: [turnOffProtection, turnOnProtection],
						type: 'RTP' })
				)
			),
			React.createElement(WhiteList, { whitelist: whitelist, dispatch: dispatch, settings: settings })
		);
	}
}
MainComponent.propTypes = {
	//info: PropTypes.object.isRequired,
};
function mapStateToPros(state) {
	let queryDict = {};
	location.search.substr(1).split("&").forEach(function (item) {
		queryDict[item.split("=")[0]] = item.split("=")[1];
	});
	return _.merge({}, state, { getParams: queryDict });
}
MainComponent = ReactRedux.connect(mapStateToPros)(MainComponent);