var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

class MainComponent extends React.Component {
    constructor(props) {
        super(props);
        this.state = this.checkState();
        this.needShareRating = true;
        this.myEvent = setInterval(() => {
            if (!this.props.info.comments.loading) {
                webextApi.runtime.sendMessage({
                    name: SEND_MESSAGE, params: {
                        [atob("ZWM=")]: "Main Window",
                        [atob("ZWE=")]: "Toolbar Open",
                        [atob("ZWw=")]: upperFirstCase(this.props.info.iconColor) + ' - ' + (this.props.info.comments.data && this.props.info.comments.data.length > 0 ? 'Has Reviews' : 'No Reviews')
                    }
                });
                clearInterval(this.myEvent);
            }
        }, 300);
        this.unsubscribeSocialLogin = this.props.store.subscribe(() => {
            if (this.props.store.getState().lastAction.type === SAVE_USER_DATA && this.state.modalType !== 'mobile' && this.state.modalType !== 'survey' && this.state.modalType !== 'CTA') {
                this.setState({
                    isModalOpen: false
                });
                this.unsubscribeSocialLogin();
            }
        });
        this.firefoxRepaintThrottled = _.throttle(firefoxRepaint, 500);
    }
    setLoadErrorCheckTimer() {
        clearTimeout(this.checkLoadErrTimer);
        this.checkLoadErrTimer = setTimeout(() => {
            !this.props.info.loaded && this.setState(_extends({}, this.state, { isLoadingError: true }));
        }, 5000);
    }
    componentDidMount() {
        this.setLoadErrorCheckTimer();
    }
    closeModal() {
        if (this.state.modalType === 'rating') {
            webextApi.runtime.sendMessage({
                name: SEND_MESSAGE, params: {
                    [atob("ZWM=")]: "Main Window",
                    [atob("ZWE=")]: "Rate Us Close",
                    [atob("ZWw=")]: ""
                }
            });
        } else if (this.state.modalType === 'mobile') {
            this.props.dispatch(mobileTrigerModalReset());
            webextApi.runtime.sendMessage({
                name: SEND_MESSAGE, params: {
                    [atob("ZWM=")]: "Main Window",
                    [atob("ZWE=")]: "Mobile Popup Close",
                    [atob("ZWw=")]: ""
                }
            });
        } else if (this.state.modalType === 'updateExtension' && this.props.store.getState().GDPRNotifications) {
            return;
        }
        this.setState({
            isModalOpen: false
        });
    }
    showNotification() {
        this.setState({
            notification: true
        });
    }
    closeNotification() {
        let notif = document.getElementsByClassName('wot-popup-notification')[0];
        notif && notif.classList.remove('wot-popup-notification_open');
        setTimeout(() => {
            this.setState({
                notification: false
            });
        }, 200);
    }
    showModal(type) {
        let attr = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        if (type === 'ratingSharing') {
            if (!this.needShareRating) {
                return;
            }
            this.needShareRating = false;
        }
        return () => {
            this.setState({
                isModalOpen: true,
                modalType: type,
                attr: attr
            });
        };
    }
    goToFullCard() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Main Window",
                [atob("ZWE=")]: "View Full Scorecard",
                [atob("ZWw=")]: this.props.info.host
            }
        });
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: FULL_REPORT_URL + this.props.info.host + MAIN_WINDOW_REDIRECT_PARAMETERS });
        window.close();
    }
    checkState() {
        let store = this.props.store.getState(),
            mobileModalTrigger = store.mobileModal.mobileModalTrigger,
            popupOpeningCounter = store.rateUsWidget.popupOpeningCounter,
            GDPRNotifications = store.GDPRNotifications;
        if (GDPRNotifications) {
            return {
                isModalOpen: true,
                modalType: 'updateExtension',
                notification: false
            };
        } else if (this.isNeedShowSurveyModal()) {
            return {
                isModalOpen: true,
                modalType: 'survey',
                notification: false
            };
        } else if (mobileModalTrigger) {
            return {
                isModalOpen: true,
                modalType: 'mobile',
                notification: false
            };
        } else if ([2, 9, 19].indexOf(popupOpeningCounter) !== -1 && this.props.store.getState().cta.status !== 'dontShowAgain') {
            this.props.dispatch(updateCtaAppearance());
            return {
                isModalOpen: true,
                modalType: 'CTA',
                notification: false
            };
        } else {
            return {
                isModalOpen: false,
                modalType: '',
                notification: false
            };
        }
    }
    shrinkHeader(e) {
        if (e.currentTarget.scrollTop > 0) {
            this.setState({
                headerShrinked: true
            });
        } else {
            this.setState({
                headerShrinked: false
            });
        }
    }
    checkUser() {
        let user = this.props.store.getState().user;
        if (Object.keys(user).length > 0) {
            return user.uid;
        }
    }
    /*shouldComponentUpdate(props, state) {
        if (props.info.host === "auth.api.mywot.com") {
            return false;
        } else {
            return true;
        }
    }*/
    componentDidUpdate() {
        const isUserLogged = Object.keys(this.props.store.getState().user).length > 0;
        if (isUserLogged) setTimeout(this.firefoxRepaintThrottled, 0);
    }
    isNeedShowSurveyModal() {
        const surveyData = this.props.store.getState().survey;
        if (surveyData.isShowed) return false;
        return new Date().getTime() - surveyData.installDate > SURVEY_SHOW_DELAY;
    }
    render() {
        var _props = this.props;
        const info = _props.info,
              dispatch = _props.dispatch;

        let haveCategories = false,
            classHeader = 'popup-container__item',
            headerStyles = {};
        info.reviews && info.reviews.step === 0 ? classHeader += ' popup-container__item_first-header' : classHeader += ' popup-container__item_header';
        info.reviews && info.reviews.step === 0 ? headerStyles.height = '344px' : headerStyles.height = '282px';
        for (let category of info.categories) {
            if (_.indexOf(CATEGORIES_RULES.popup, category.id) !== -1) {
                haveCategories = true;
            }
        }
        return React.createElement(
            "div",
            { className: this.state.headerShrinked ? "main-popup-container popup-container_shrinked" : "main-popup-container" },
            React.createElement(
                "div",
                { className: classHeader, style: headerStyles },
                React.createElement(
                    "div",
                    { className: "popup-container__header" },
                    React.createElement(MenuButton, { host: info.host, store: this.props.store, showModal: this.showModal.bind(this) }),
                    React.createElement(
                        "a",
                        { onClick: this.goToFullCard.bind(this), className: "header__viewaway" },
                        webextApi.i18n.getMessage("viewFullScorecard") + " ►"
                    ),
                    Object.keys(this.props.store.getState().user).length > 0 && React.createElement(
                        "div",
                        { className: "user-level" },
                        React.createElement("span", { className: "user-level__label" + (this.props.store.getState().user.roles && this.props.store.getState().user.roles[6] ? " user-level__label_" + this.props.store.getState().user.roles[6] : "") }),
                        React.createElement(
                            "span",
                            { className: "user-level__name" },
                            this.props.store.getState().user.roles && this.props.store.getState().user.roles[6] && this.props.store.getState().user.roles[6].charAt(0).toUpperCase() + this.props.store.getState().user.roles[6].substr(1).toLowerCase() + ' '
                        )
                    )
                ),
                React.createElement(
                    "div",
                    { className: "popup-container__title" },
                    React.createElement(
                        "div",
                        { className: "popup-container__header__host" },
                        truncateString(WotApi.getDecodedDomain(info.host))
                    ),
                    info.childSafety === NOT_SAFE && React.createElement(
                        "div",
                        { className: "child-label" },
                        webextApi.i18n.getMessage("NotAppropriate")
                    )
                ),
                React.createElement(
                    "div",
                    { className: "popup-container__bubble" },
                    React.createElement(SecurityBubble, { safety: info.safety, color: info.bubbleColor }),
                    React.createElement(ReputationBubble, { rating: +info.rating, confidence: +info.confidence })
                ),
                !info.loaded && React.createElement(PopupLoader, null),
                this.state.isLoadingError && React.createElement(LoadingError, null),
                info.reviews && info.reviews.step === 0 && React.createElement(
                    "div",
                    { className: "popup-container__labels" },
                    React.createElement(WarningReportsContainer, { categories: info.categories, isInPopup: true,
                        host: info.host })
                )
            ),
            React.createElement(RatingFlowTest, { reviews: info.reviews,
                host: info.host,
                dispatch: dispatch,
                comments: info.comments,
                showModal: this.showModal.bind(this),
                userId: this.checkUser(),
                userName: this.props.store.getState().user.name,
                picture: this.props.store.getState().user.picture,
                shrinkHeader: this.shrinkHeader.bind(this),
                count: info.count,
                iconColor: this.props.info.iconColor }),
            this.state.isModalOpen && React.createElement(ModalMessage, { onClose: this.closeModal.bind(this), showModal: this.showModal.bind(this), showNotification: this.showNotification.bind(this), modalType: this.state.modalType, className: "modal-message", store: this.props.store, host: info.host, reviews: info.reviews }),
            this.state.notification && React.createElement(Notification, { onClose: this.closeNotification.bind(this) }),
            React.createElement(PopupFooter, { popupOpeningCounter: this.props.store.getState().rateUsWidget.popupOpeningCounter, showModal: this.showModal.bind(this) })
        );
    }
}
MainComponent.propTypes = {};
function mapStateTpPros(state) {
    let currentTab = _.filter(state.tabs, tab => {
        return tab.active;
    })[0],
        host = currentTab && WotApi.getEncodedDomain(currentTab.url),
        color,
        count = 0;
    for (let hostanme in state.reviews[state.user && state.user.uid || 1]) {
        if (state.reviews[state.user && state.user.uid || 1][hostanme].step >= LAST_STEP + 1) {
            count++;
        }
    }
    if (host && state.ratings[host] && state.ratings[host].rating > 0) {
        switch (state.ratings[host].safety) {
            case UNKNOWN:
                color = 'gray';
                break;
            case NOT_SAFE:
                color = 'red';
                break;
            case SUSPICIOUS:
                color = 'yellow';
                break;
            case SAFE:
                color = 'green';
                break;
            default:
                break;
        }
        return {
            info: {
                loaded: !!state.ratings[host],
                rating: state.ratings[host].rating,
                comments: _.merge(state.comments[host], { loading: state.comments.loading }),
                confidence: state.ratings[host].confidence,
                categories: state.ratings[host].categories,
                safety: state.ratings[host].safety,
                childSafety: state.ratings[host].childSafety,
                bubbleColor: color,
                experimentalFeature: state.experimentalFeature.status,
                reviews: state.reviews[state.user && state.user.uid || 1] && state.reviews[state.user && state.user.uid || 1][host],
                count: count,
                host: host,
                iconColor: getDonutColor(state.ratings[host], state.reviews[state.user && state.user.uid || 1] && state.reviews[state.user && state.user.uid || 1][host]).color
            }
        };
    } else {
        return {
            info: {
                loaded: !!state.ratings[host],
                rating: '',
                comments: _.merge(state.comments[host], { loading: state.comments.loading }),
                confidence: '',
                categories: [],
                host: host || 'not host',
                bubbleColor: 'gray',
                experimentalFeature: state.experimentalFeature.status,
                reviews: state.reviews[state.user && state.user.uid || 1] && state.reviews[state.user && state.user.uid || 1][host],
                safety: 'UNKNOWN',
                count: count,
                iconColor: getDonutColor(state.ratings[host], state.reviews[state.user && state.user.uid || 1] && state.reviews[state.user && state.user.uid || 1][host]).color
            }
        };
    }
}
MainComponent = ReactRedux.connect(mapStateTpPros)(MainComponent);