
class ModalFeedback extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
			textComment: ''
		};
	}
	textChange(e) {
		this.setState({
			textComment: e.currentTarget.value
		});
	}
	submit() {
		let btnType = this.state.textComment.length === 0 ? 'disable' : 'green';
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Rate Us Feedback Send",
				[atob("ZWw=")]: btnType === 'green' ? 'Enabled' : 'Disabled'
			}
		});
		if (btnType === 'green') {
			document.querySelector("#submitFeedback") && document.querySelector("#submitFeedback").click();
			this.props.showNotification();
			this.props.onClose();
		}
	}
	clickNoThanks() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Rate Us Feedback No Thanks",
				[atob("ZWw=")]: ""
			}
		});
		this.props.onClose();
	}
	validForm() {
		document.querySelector(".modal-message_feedback").childNodes[1].submit();
	}
	render() {
		let btnType = this.state.textComment.length === 0 ? 'disable' : 'green';
		return React.createElement(
			'div',
			{ className: 'modal-message_feedback' },
			React.createElement(
				'div',
				{ className: 'modal-message_feedback__header' },
				React.createElement(
					'div',
					{ className: 'modal-message__header modal-message__header_rate-header' },
					webextApi.i18n.getMessage('HowCanWeImprove')
				),
				React.createElement(
					'div',
					{ className: 'modal-message__header modal-message__header_rate-text' },
					webextApi.i18n.getMessage('TakeMoment')
				)
			),
			React.createElement(
				'form',
				{
					action: FEEDBACK_FORM_ACTION,
					target: '_self', method: 'POST' },
				React.createElement(
					'div',
					{ className: 'modal-message_feedback__input' },
					React.createElement(
						'div',
						{ style: { display: "none" } },
						React.createElement('input', { type: 'radio', name: 'entry.778079546', id: 'e1', value: '1 star' }),
						React.createElement(
							'label',
							{ htmlFor: 'e1' },
							'1 star'
						),
						React.createElement('input', { type: 'radio', name: 'entry.778079546', id: 'e2', value: '2 stars' }),
						React.createElement(
							'label',
							{ htmlFor: 'e2' },
							'2 stars'
						),
						React.createElement('input', { type: 'radio', name: 'entry.778079546', id: 'e3', value: '3 stars' }),
						React.createElement(
							'label',
							{ htmlFor: 'e3' },
							'3 stars'
						),
						React.createElement('input', { type: 'radio', name: 'entry.778079546', id: 'e4', value: '4 stars' }),
						React.createElement(
							'label',
							{ htmlFor: 'e4' },
							'4 stars'
						)
					),
					React.createElement(
						'label',
						{ style: { display: "none" }, htmlFor: 'feedback' },
						'What to improve?'
					),
					React.createElement('textarea', { id: 'feedback', name: 'entry.986001465',
						placeholder: webextApi.i18n.getMessage('GiveUsSomeFeedback'),
						onChange: this.textChange.bind(this) })
				),
				React.createElement(
					'div',
					{ className: 'modal-message_feedback__buttons' },
					React.createElement(
						'div',
						{
							className: 'modal-message__button-container__item modal-message__button-container__item_no-thanks',
							onClick: this.clickNoThanks.bind(this) },
						webextApi.i18n.getMessage('noThanks')
					),
					React.createElement('input', { id: 'submitFeedback', type: 'button', style: { display: "none" }, value: 'Submit', onClick: this.validForm.bind(this) }),
					React.createElement(
						SimpleButton,
						{ className: 'rating-flow__add-comment__footer__btn',
							type: btnType, onClick: this.submit.bind(this) },
						webextApi.i18n.getMessage('Send')
					)
				)
			)
		);
	}
}