function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

class RatingFlowAddComment extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            textComment: this.props.reviews.comment ? this.props.reviews.comment : ''
        };
    }
    textChange(e) {
        this.setState({
            textComment: e.currentTarget.value
        });
        setTimeout(() => {
            this.props.dispatch(addCommentReview(this.props.host, this.state.textComment, Date.now() / 1000, this.props.userId));
        }, 0);
    }
    nextStep() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Step 7 No, Thanks",
                [atob("ZWw=")]: ""
            }
        });
        validateDomain(this.props.host) && webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Submit No Comment Manual",
                [atob("ZWw=")]: validateDomain(this.props.host)
            }
        });
        this.props.dispatch(toNextStep(this.props.host, this.props.userId));
        this.props.dispatch(mobileRateCount());
        (this.props.count + 1 === 1 || (this.props.count + 1) % 5 === 0) && this.showModalLogOut('ratingSharing')();
    }
    saveReviewComment() {
        const tags = [].concat(_toConsumableArray(_.get(this.props.reviews, 'childSafetyCategories', [])), _toConsumableArray(_.get(this.props.reviews, 'reputationCategories', [])), _toConsumableArray(_.get(this.props.reviews, 'safetyCategories', [])));
        const timestamp = Date.now() / 1000;
        this.props.dispatch(saveCommentAndReview(this.props.host, this.state.textComment, timestamp, tags, this.props.reviews.rating, this.props.userId));
    }
    addCommentClick() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Step 7 Submit",
                [atob("ZWw=")]: this.state.textComment.length
            }
        });
        validateDomain(this.props.host) && webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Submit With Comment",
                [atob("ZWw=")]: validateDomain(this.props.host)
            }
        });
        this.saveReviewComment();
        this.props.dispatch(toNextStep(this.props.host, this.props.userId));
        this.props.dispatch(mobileRateCount());
        (this.props.count + 1 === 1 || (this.props.count + 1) % 5 === 0) && this.showModalLogOut('ratingSharing')();
    }
    showModalLogOut(type) {
        return () => {
            webextApi.runtime.sendMessage({
                name: SEND_MESSAGE, params: {
                    [atob("ZWM=")]: "Rating Flow",
                    [atob("ZWE=")]: "Step 7 " + type,
                    [atob("ZWw=")]: ""
                }
            });
            this.props.showModal(type)();
        };
    }
    componentWillUnmount() {
        this.props.dispatch(addCommentReview(this.props.host, this.state.textComment, Date.now() / 1000, this.props.userId));
        this.props.dispatch(clearComments(this.props.host));
        this.props.dispatch(getComments(this.props.host));
    }
    noThanks() {
        this.setState({
            textComment: ''
        });
        setTimeout(() => {
            this.saveReviewComment();
            this.props.dispatch(addCommentReview(this.props.host, '', Date.now() / 1000, this.props.userId));
            this.nextStep();
        }, 0);
    }
    render() {
        var _props = this.props;
        const reviews = _props.reviews,
              userId = _props.userId;

        let classSafetyLogo = 'rating-flow__result__message__safety-logo rating-flow__result__message__safety-logo_' + getDonutColor(false, reviews, 5).color,
            btnType = this.state.textComment.length === 0 ? 'disable' : 'green';
        return React.createElement(
            "div",
            { className: "rating-flow__add-comment" },
            React.createElement(
                "div",
                { className: "rating-flow__add-comment__header" },
                React.createElement(
                    "span",
                    null,
                    webextApi.i18n.getMessage('WriteReview')
                ),
                React.createElement(
                    "div",
                    { className: "rating-flow__result__message__items" },
                    reviews.childSafety === false && React.createElement("div", { className: "rating-flow__result__message__child-logo" }),
                    React.createElement("div", { className: classSafetyLogo }),
                    React.createElement(
                        "div",
                        { className: "rating-flow__result__message__rating" },
                        React.createElement(RatingStarsContainer, { type: "_small", rating: reviews.rating })
                    )
                )
            ),
            !!userId ? React.createElement(
                "textarea",
                { placeholder: webextApi.i18n.getMessage('WriteYourReview'), onChange: this.textChange.bind(this) },
                reviews.comment && reviews.comment
            ) : React.createElement(
                "div",
                { className: "rating-flow__add-comment_logout" },
                React.createElement(
                    "div",
                    null,
                    React.createElement(
                        "a",
                        { href: "#", onClick: this.showModalLogOut('login') },
                        webextApi.i18n.getMessage('logIn')
                    ),
                    React.createElement(
                        "span",
                        null,
                        webextApi.i18n.getMessage('or')
                    ),
                    React.createElement(
                        "a",
                        { href: "#", onClick: this.showModalLogOut('signup') },
                        webextApi.i18n.getMessage('SignUp')
                    ),
                    React.createElement(
                        "span",
                        null,
                        webextApi.i18n.getMessage('toWriteReview')
                    )
                )
            ),
            React.createElement(
                "div",
                { className: "rating-flow__add-comment__footer" },
                React.createElement(
                    "a",
                    { href: "#", onClick: this.noThanks.bind(this) },
                    webextApi.i18n.getMessage('noThanks')
                ),
                !!userId && React.createElement(
                    SimpleButton,
                    { className: "rating-flow__add-comment__footer__btn",
                        type: btnType,
                        onClick: btnType === 'green' && this.addCommentClick.bind(this) },
                    webextApi.i18n.getMessage('Submit')
                )
            )
        );
    }
}