
class RatingFlowSafe extends React.Component {
	sendOnce() {
		if (!window['sended' + this.props.step]) {
			validateDomain(this.props.host) && webextApi.runtime.sendMessage({
				name: SEND_MESSAGE, params: {
					[atob("ZWM=")]: "Rating Flow",
					[atob("ZWE=")]: "Step " + this.props.step + " Tooltip",
					[atob("ZWw=")]: validateDomain(this.props.host)
				}
			});
			window['sended' + this.props.step] = true;
		}
	}
	notSure() {
		this.props.dispatch(this.props.type === 'child' ? rateChildSafety(this.props.host, -1) : rateSafety(this.props.host, -1), this.props.userId);
		this.props.dispatch(overNextStep(this.props.host, this.props.userId)); //TODO user id
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Rating Flow",
				[atob("ZWE=")]: this.props.type === 'child' ? "Step 3 Submit" : "Step 1 Submit",
				[atob("ZWw=")]: 'Not Sure'
			}
		});
	}
	render() {
		var _props = this.props;
		const type = _props.type,
		      dispatch = _props.dispatch,
		      host = _props.host,
		      step = _props.step,
		      tooltipText = _props.tooltipText,
		      userId = _props.userId;

		let classContainer = 'rating-flow';
		classContainer += ' rating-flow_first';
		return React.createElement(
			"div",
			{ className: classContainer },
			React.createElement(Tooltip, { text: tooltipText, onMouseEnter: this.sendOnce.bind(this) }),
			React.createElement(
				"div",
				{ className: "rating-flow_safe" },
				React.createElement(
					"div",
					{ className: "rating-flow_safe__header" },
					React.createElement(FormattedString, { text: webextApi.i18n.getMessage('siteIsSafe' + (type === 'normal' ? '' : 'Children')) })
				),
				React.createElement(
					"div",
					{ className: "rating-flow_safe__buttons" },
					React.createElement(ButtonAction, { typeAction: type === 'child' ? 'RatingFlowChild' : 'RatingFlow', commonComponent: "Rating Flow",
						text: webextApi.i18n.getMessage('no'), dispatch: dispatch, host: host, userId: userId }),
					React.createElement(ButtonAction, { typeAction: type === 'child' ? 'RatingFlowChild' : 'RatingFlow', commonComponent: "Rating Flow",
						text: webextApi.i18n.getMessage('yes'), dispatch: dispatch, host: host, userId: userId })
				),
				React.createElement(
					"div",
					{ className: "rating-flow_safe__not",
						onClick: this.notSure.bind(this) },
					webextApi.i18n.getMessage('notSure'),
					React.createElement(
						"span",
						{
							className: "rating-flow_safe__not__span" },
						"\u203A"
					)
				)
			),
			React.createElement(RatingFlowFooter, { typeNextButton: "none",
				dispatch: dispatch,
				host: host,
				step: step,
				nextAction: overNextStep,
				userId: userId })
		);
	}
}