
class RatingFlowResultPage extends React.Component {
	constructor(props) {
		super(props);
	}
	onEditClick() {
		this.props.dispatch(editReview(this.props.host, this.props.userId));
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Rating Flow",
				[atob("ZWE=")]: "Edit",
				[atob("ZWw=")]: ""
			}
		});
	}
	onDeleteClick() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Rating Flow",
				[atob("ZWE=")]: "Delete Open",
				[atob("ZWw=")]: ""
			}
		});
		this.props.showModal('deleteReview')();
	}
	goToFacebookPage() {
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: getFacebookSharingUrl(this.props.host, this.props.reviews.rating) });
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Rating Flow",
				[atob("ZWE=")]: "Share Facebook",
				[atob("ZWw=")]: ""
			}
		});
		window.close();
	}
	goToTwitterPage() {
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: getTwitterSharingUrl(this.props.host, this.props.reviews.rating) });
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Rating Flow",
				[atob("ZWE=")]: "Share Twitter",
				[atob("ZWw=")]: ""
			}
		});
		window.close();
	}
	goToGooglePage() {
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: getGoogleSharingUrl(this.props.host, this.props.reviews.rating) });
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Rating Flow",
				[atob("ZWE=")]: "Share Google+",
				[atob("ZWw=")]: ""
			}
		});
		window.close();
	}
	render() {
		var _props = this.props;
		const reviews = _props.reviews,
		      host = _props.host,
		      userName = _props.userName,
		      dispatch = _props.dispatch,
		      comments = _props.comments,
		      picture = _props.picture;

		let classSafetyLogo = 'rating-flow__result__message__safety-logo rating-flow__result__message__safety-logo_' + getDonutColor(false, reviews).color;
		return React.createElement(
			"div",
			{ className: "rating-flow__result" },
			React.createElement(
				"div",
				{ className: "rating-flow__result__message" },
				React.createElement(
					"div",
					{ className: "rating-flow__result__message__text" },
					webextApi.i18n.getMessage('yourRating')
				),
				React.createElement(
					"div",
					{ className: "rating-flow__result__message__items" },
					reviews.childSafety === false && React.createElement("div", { className: "rating-flow__result__message__child-logo" }),
					React.createElement("div", { className: classSafetyLogo }),
					React.createElement(
						"div",
						{ className: "rating-flow__result__message__rating" },
						React.createElement(RatingStarsContainer, { type: "_small", rating: reviews.rating })
					),
					React.createElement("div", { className: "rating-flow__result__message__edit", onClick: this.onEditClick.bind(this) }),
					React.createElement("div", { className: "rating-flow__result__message__delete", onClick: this.onDeleteClick.bind(this) })
				)
			),
			React.createElement(CommentsList, { comments: comments,
				dispatch: dispatch,
				host: host,
				reviews: reviews,
				userName: userName,
				picture: picture,
				bubbles: getDonutColor(false, reviews).color })
		);
	}
}