function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

class RatingFlowFooterTest extends React.Component {
	back() {
		let backAction = toPreviousStep;
		validateDomain(this.props.host) && webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "B Rating Flow",
				[atob("ZWE=")]: "B Step " + this.props.step + " Back",
				[atob("ZWw=")]: validateDomain(this.props.host)
			}
		});
		if (this.props.rating !== -1 && this.props.step !== 1) {
			switch (true) {
				case this.props.rating === 60 && this.props.step !== 4:
					backAction = overPreviousStep;
					break;
				case this.props.rating === 80 || this.props.rating === 100:
					backAction = triplePreviousStep;
					break;
			}
		}
		this.props.dispatch(backAction(this.props.host, this.props.userId));
	}
	sendReviewInfo() {
		const reviews = _.get(store.getState().reviews, `${this.props.userId}['${this.props.host}']`, {});
		const tags = [].concat(_toConsumableArray(_.get(reviews, 'childSafetyCategories', [])), _toConsumableArray(_.get(reviews, 'reputationCategories', [])), _toConsumableArray(_.get(reviews, 'safetyCategories', [])));
		this.props.dispatch(saveCommentAndReview(this.props.host, '', Date.now() / 1000, tags, this.props.rating, this.props.userId));
	}
	next() {
		switch (this.props.step) {
			case 1:
				webextApi.runtime.sendMessage({
					name: SEND_MESSAGE, params: {
						[atob("ZWM=")]: "B Rating Flow",
						[atob("ZWE=")]: "B Step " + this.props.step + " Submit",
						[atob("ZWw=")]: (this.props.rating / 20).toFixed()
					}
				});
				break;
			case 2:
				this.props.categories && webextApi.runtime.sendMessage({
					name: SEND_MESSAGE, params: {
						[atob("ZWM=")]: "Rating Flow",
						[atob("ZWE=")]: "Step " + this.props.step + " Submit",
						[atob("ZWw=")]: this.props.categories.join(',')
					}
				});
				this.props.dispatch(rateSafety(this.props.host, this.props.categories && this.props.categories[0] ? false : true, this.props.userId));
				break;
			case 3:
				this.props.categories && webextApi.runtime.sendMessage({
					name: SEND_MESSAGE, params: {
						[atob("ZWM=")]: "Rating Flow",
						[atob("ZWE=")]: "Step " + this.props.step + " Submit",
						[atob("ZWw=")]: this.props.categories.join(',')
					}
				});
				break;
			case 4:
				webextApi.runtime.sendMessage({
					name: SEND_MESSAGE, params: {
						[atob("ZWM=")]: "B Rating Flow",
						[atob("ZWE=")]: "B Submit No Comment Auto",
						[atob("ZWw=")]: this.props.categories.join(',')
					}
				});
				this.props.dispatch(rateChildSafety(this.props.host, this.props.categories && this.props.categories[0] ? false : true, this.props.userId));
				this.sendReviewInfo();
				break;
			default:
				validateDomain(this.props.host) && webextApi.runtime.sendMessage({
					name: SEND_MESSAGE, params: {
						[atob("ZWM=")]: "B Rating Flow",
						[atob("ZWE=")]: "B Step " + this.props.step + " Submit",
						[atob("ZWw=")]: validateDomain(this.props.host)
					}
				});
		}
		if (this.props.typeNextButton === 'active') {
			switch (true) {
				case this.props.step === 1 && this.props.rating === 60:
					this.props.dispatch(deleteReviewBeforeReputation(this.props.host, this.props.userId));
					this.props.dispatch(overNextStep(this.props.host, this.props.userId));
					break;
				case this.props.step === 1 && (this.props.rating === 80 || this.props.rating === 100):
					this.props.dispatch(deleteReviewBeforeChild(this.props.host, this.props.userId));
					this.props.dispatch(tripleNextStep(this.props.host, this.props.userId));
					break;
				default:
					return this.props.dispatch(toNextStep(this.props.host, this.props.userId));
			}
		}
	}
	render() {
		var _props = this.props;
		const typeNextButton = _props.typeNextButton,
		      step = _props.step;

		let classNameNextButton = 'rating-flow__footer__next';
		switch (typeNextButton) {
			case 'active':
				classNameNextButton += ' rating-flow__footer__next_active';
				break;
			case 'disable':
				classNameNextButton += ' rating-flow__footer__next_disable';
				break;
			default:
				classNameNextButton += ' rating-flow__footer__next_none';
				break;
		}
		return React.createElement(
			"div",
			{ className: "rating-flow__footer" },
			step !== 0 && React.createElement(
				"div",
				{ className: "rating-flow__footer__back " + (step === 1 ? "invisible" : ""), onClick: this.back.bind(this) },
				React.createElement(
					"span",
					{
						className: "rating-flow__footer__back__span" },
					"\u2039"
				),
				webextApi.i18n.getMessage('back')
			),
			React.createElement(
				"div",
				{ className: classNameNextButton,
					onClick: this.next.bind(this) },
				this.props.skipOpprtunity ? this.props.categories && this.props.categories.length > 0 ? webextApi.i18n.getMessage('next') : webextApi.i18n.getMessage('noSkip') : webextApi.i18n.getMessage('next'),
				React.createElement(
					"span",
					{ className: "rating-flow__footer__next__span" },
					"\u203A"
				)
			)
		);
	}
}