var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

class RatingFlowLabelsTest extends React.Component {
    render() {
        var _props = this.props;
        const dispatch = _props.dispatch,
              host = _props.host,
              categories = _props.categories,
              typeCategories = _props.typeCategories,
              step = _props.step,
              clickLabelAction = _props.clickLabelAction,
              rating = _props.rating,
              userId = _props.userId;

        let classContainer = 'rating-flow',
            testHeader = '',
            locale = getLocale(),
            os = getOS(),
            style = locale.indexOf('en') !== 0 && os.indexOf('Mac') != -1 && browserName === 'firefox' ? { marginBottom: '17px' } : {},
            categoriesArray = _.sortBy(CATEGORIES_RULES.ratingFlow[typeCategories], item => {
            return webextApi.i18n.getMessage(ALL_CATEGORIES[item].description).length;
        });
        switch (typeCategories) {
            case 'safety':
                testHeader = webextApi.i18n.getMessage("notSecurity");
                break;
            case 'reputation':
                testHeader = webextApi.i18n.getMessage("chooseTagsThatDescribes");
                break;
            case 'childSafety':
                testHeader = webextApi.i18n.getMessage("notSuitableForChildren");
                break;
        }
        return React.createElement(
            'div',
            { className: classContainer },
            React.createElement(
                'div',
                { className: 'rating-flow-labels' },
                React.createElement(
                    'div',
                    { className: 'rating-flow_safe__header  rating-flow_safe__header_not-safe' },
                    React.createElement(
                        'div',
                        { className: 'rating-flow-labels_not-safe' },
                        testHeader
                    )
                ),
                React.createElement(
                    Scrollbars,
                    { className: 'warning-reports-container',
                        hideTracksWhenNotNeeded: true,
                        renderView: props => React.createElement('div', _extends({}, props, { className: 'warning-reports-scroll' })),
                        autoHide: false },
                    React.createElement(
                        'div',
                        { className: 'warning-reports-container-flex', style: style },
                        CATEGORIES_RULES.ratingFlow[typeCategories].map(item => {
                            let classNameReport = 'warning-reports-container__label warning-reports-container__label_rating-flow';
                            if (_.indexOf(categories, +item) !== -1) {
                                classNameReport += ' warning-reports-container__label_' + ALL_CATEGORIES[item].color;
                            }
                            return React.createElement(
                                'div',
                                { className: classNameReport, data: item, onClick: () => {
                                        dispatch(clickLabelAction(host, item, userId));
                                    } },
                                webextApi.i18n.getMessage(ALL_CATEGORIES[item].description)
                            );
                        })
                    )
                ),
                React.createElement(
                    'div',
                    { className: 'rating-flow-labels_click' },
                    webextApi.i18n.getMessage("clickAllTags")
                )
            ),
            React.createElement(RatingFlowFooterTest, {
                categories: categories,
                skipOpprtunity: true,
                userId: this.props.userId,
                typeNextButton: 'active',
                dispatch: dispatch,
                host: host,
                step: step,
                rating: rating })
        );
    }
}